#! /bin/sh
# 
# This file is part of Transformers.
# Copyright (C) 2008  EPITA Research and Development Laboratory.
#
# Transformers is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
# USA.

set -e
. $top_srcdir/config/common.sh

_dispatch ()
{
  echo $input
  VERBOSE=0
  parse_c=$abs_top_builddir/c-grammar/src/parser/parse-c99
  af=$top_builddir/contract-c/src/syn/ContractC.pp.af 
  parse_pipeline "$parse_c" "$input" "$@" -p ContractC | \
    XTC_REPOSITORY=$BUILD_REPOSITORY \
    $top_builddir/contract-c/src/str/contract-c | \
    $SDF_TOOLS/bin/ast2text -p $af \
     > $dir/output.c

  mv $dir/output.c $dir/output.c.bak
  perl -e 'open (FILE, "'$dir'/output.c.bak") || die ("cant open file");
          $qHasHead=0;
          while (<FILE>) {
            if ($qHasHead) { print }
            elsif (/^int cut_me_here_please/) {$qHasHead=1; print}
          };
          close (FILE)' > $dir/output.c

  cd  "$dir"
  diff -w >&2 "$noext.c" "output.c" >"output.diff"
  if test -s "output.diff"; then
    stderr "Test failed"
    cat >&2 "output.diff"
    exit 1
  fi
}

test_main "$@"
